/*
 * Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */


package session;

import entity.UserCredential;

import javax.ejb.Stateless;
import javax.ejb.Remote;
import javax.ejb.Stateful;
import javax.ejb.Remove;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.EntityTransaction;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceUnit;
import javax.persistence.Persistence;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.persistence.Tuple;
import javax.persistence.TypedQuery;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;
import java.util.List;
import java.util.Iterator;

/**
 * @author Mitesh Meswani
 */
@Stateless
@Remote(SInterface.class)
public class SBean implements SInterface {
    @PersistenceContext(unitName = "em") EntityManager em;

    public void m1() {
        System.out.println("In method m1");
        System.out.println("Exiting m1");
    }

    public void persist(UserCredential credential) {
        em.persist(credential);
    }

    public UserCredential query(String name) {
        CriteriaBuilder qbuilder = em.getCriteriaBuilder();

            CriteriaQuery<UserCredential> cquery = qbuilder.createQuery(UserCredential.class);
            Root<UserCredential> root = cquery.from(UserCredential.class);
            cquery.where(qbuilder.equal(root.get("name"), qbuilder.parameter(String.class, "name")));
            TypedQuery<UserCredential> tquery = em.createQuery(cquery);
            tquery.setParameter("name", name);
            List<UserCredential> resultList = tquery.getResultList();
            return resultList.get(0);

        //return em.find(UserCredential.class, name);
    }
}
